﻿#region Copyright (C) 2003-2015 Stimulsoft
/*
{*******************************************************************}
{																	}
{	StimulReport.Net												}
{	Stimulsoft.Report Library										}
{																	}
{	Copyright (C) 2003-2015 Stimulsoft     							}
{	ALL RIGHTS RESERVED												}
{																	}
{	The entire contents of this file is protected by U.S. and		}
{	International Copyright Laws. Unauthorized reproduction,		}
{	reverse-engineering, and distribution of all or any portion of	}
{	the code contained in this file is strictly prohibited and may	}
{	result in severe civil and criminal penalties and will be		}
{	prosecuted to the maximum extent possible under the law.		}
{																	}
{	RESTRICTIONS													}
{																	}
{	THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES			}
{	ARE CONFIDENTIAL AND PROPRIETARY								}
{	TRADE SECRETS OF Stimulsoft										}
{																	}
{	CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON		}
{	ADDITIONAL RESTRICTIONS.										}
{																	}
{*******************************************************************}
*/
#endregion Copyright (C) 2003-2015 Stimulsoft

using System;
using System.Collections;
using System.Data;
using System.ComponentModel;
using Stimulsoft.Base;
using Stimulsoft.Base.Localization;
using Stimulsoft.Base.Serializing;
using Stimulsoft.Report.Events;
using Stimulsoft.Report.Dictionary.Design;
using Devart.Data.Oracle;


namespace Stimulsoft.Report.Dictionary
{
    [TypeConverter(typeof(StiSqlSourceConverter))]
    public class StiDotConnectOracleSource : StiSqlSource
    {
        #region DataAdapter
        protected override Type ConvertDbTypeToTypeInternal(int sqlType)
        {
            return typeof(string);
        }

        public override void UpdateParameters()
        {
            if (this.DataTable != null)
            {
                InvokeConnecting();
                foreach (StiDataParameter parameter in Parameters)
                {
                    ((OracleDataAdapter)DataAdapter).SelectCommand.Parameters[parameter.Name].Value = parameter.ParameterValue;
                }
                DataTable dataTable = this.DataTable;
                dataTable.Rows.Clear();

                ((OracleDataAdapter)DataAdapter).SelectCommand.CommandTimeout = this.CommandTimeout;
                ((OracleDataAdapter)DataAdapter).Fill(dataTable);

                CheckColumnsIndexs();
            }
        }


        protected override string DataAdapterType
        {
            get
            {
                return "Stimulsoft.Report.Dictionary.StiDotConnectOracleAdapterService";
            }
        }
        #endregion

        #region this
        public StiDotConnectOracleSource()
            : this("", "", "")
        {
        }

        public StiDotConnectOracleSource(string nameInSource, string name)
            : this(nameInSource, name, name)
        {
        }

        public StiDotConnectOracleSource(string nameInSource, string name, string alias)
            : this(nameInSource, name, alias, string.Empty)
        {

        }

        public StiDotConnectOracleSource(string nameInSource, string name, string alias, string sqlCommand)
            :
            base(nameInSource, name, alias, sqlCommand)
        {
        }

        public StiDotConnectOracleSource(string nameInSource, string name, string alias, string sqlCommand,
            bool connectOnStart)
            :
        base(nameInSource, name, alias, sqlCommand, connectOnStart)
        {
        }

        public StiDotConnectOracleSource(string nameInSource, string name, string alias, string sqlCommand,
            bool connectOnStart, bool reconnectOnEachRow)
            :
        base(nameInSource, name, alias, sqlCommand, connectOnStart, reconnectOnEachRow)
        {
        }

        public StiDotConnectOracleSource(string nameInSource, string name, string alias, string sqlCommand,
            bool connectOnStart, bool reconnectOnEachRow, int commandTimeout)
            :
            base(nameInSource, name, alias, sqlCommand, connectOnStart, reconnectOnEachRow, commandTimeout)
        {
        }

        public StiDotConnectOracleSource(string nameInSource, string name, string alias, string sqlCommand,
    bool connectOnStart, bool reconnectOnEachRow, int commandTimeout, string key)
            :
            base(nameInSource, name, alias, sqlCommand, connectOnStart, reconnectOnEachRow, commandTimeout, key)
        {
        }

        #endregion
    }

}